﻿@{
    Layout = null;
}
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <title>@ViewBag.Title   </title>

    @Scripts.Render("~/bundles/modernizr")
    <link rel="stylesheet" href="~/Content/vendors/mdi/css/materialdesignicons.min.css">
    <link rel="stylesheet" href="~/Content/vendors/base/vendor.bundle.base.css">
    <link rel="stylesheet" href="~/Content/css/style.css">
    <link rel="shortcut icon" href="images/favicon.png" />
    <link rel="stylesheet" href="~/Content/css/jquery-ui.min.css">
    @Scripts.Render("~/bundles/jquery")
    @Scripts.Render("~/bundles/jqueryval")
    <link rel="stylesheet" href="~/Content/Site.css">
    <link rel="stylesheet" href="~/Content/css/toastr.css">

</head>


<body>
    <div class="container-scroller">
        <div class="loader"></div>
        @Html.Partial("_HeaderView")
        <div class="container-fluid page-body-wrapper">
            <nav class="sidebar sidebar-offcanvas" id="sidebar">
                <ul class="nav">

                    <li class="nav-item">

                        <div class="" id="ui-basic">
                            <ul class="nav flex-column sub-menu" id="list-menu">
                            </ul>
                        </div>
                    </li>

                </ul>
            </nav>
            <div class="main-panel">
                <div class="content-wrapper">
                    <div class="row">
                        <div class="col-md-12 grid-margin">
                            <div class="card bg-gradient-primary border-0">
                                <div class="card-body py-3 px-4 d-flex align-items-center justify-content-between flex-wrap">
                                    <p class="mb-0 text-white font-weight-medium"> Kindly download each files and fill, then upload them in respective fields</p>
                                   
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="row">

                        <div class="col-sm-12">
                            <div class="card" id="session">
                                <h2 class="card-header text-center">Section (<span id="questionCategory"></span>) </h2>


                                <div class="card-body">
                                    <h5 class="card-title"></h5>
                                    <form id="form-questn">
                                        <div class="card-body py-3 px-4 d-flex align-items-center justify-content-between flex-wrap">
                                          

                                        </div>
                                    </form>
                                </div>
                                <div class="card-footer float-btn">
                                    @*<a href="#" class="btn btn-danger">Save Session</a> &nbsp; &nbsp;*@
                                    <span class="" id="btnSave">  </span>
                                </div>
                            </div>
                        </div>

                    </div>
                </div>
                <footer class="footer">
                    <div class="d-sm-flex justify-content-center justify-content-sm-between">
                        <span class="text-muted text-center text-sm-left d-block d-sm-inline-block">Copyright © 2020 <a href="https://www.ubagroup.com/" target="_blank">UBA Group</a>. All rights reserved.</span>
                    </div>
                </footer>
            </div>
        </div>
    </div>

    <script type="text/javascript">
    var allQuestions = [];
        var counter = 0;
        var sessionTotal = 0;
        var counterAns = 0;
        var fileUpload = [];
        var fileCheck = "";

     var optionListUrl = '@Url.Action("GetAllQuestionsAsync", "AssessmentPortal")';
        questionArray();
        
        // Display all question
    function questionArray() {
        $.ajax({
            type: 'GET',
            url: optionListUrl,
           // data: "",
            dataType: 'json',
            success: function (data) {
                allQuestions = data.data;
                $.each(allQuestions, function (i, value) {
                    $("#list-menu").append($('<li class="nav-item">  <a class="nav-link" href="#" onclick=moveCategory(' + i + ') id="check' + i + '" > ' + value.CategoryName + '</a></li>'));

                });
                   displayCategoryQuestions(counter)
            }
        });
        }

        function displayCategoryQuestions(value) {
            counter = value;
            $('#fileSaved').empty();
             var cateId = allQuestions[value].QuestionCategoryId;
            $("#questionCategory").html(allQuestions[counter].CategoryName);
            formFileUpload(cateId);
            $("[id*='check']").removeClass("active");
            $("#check" + counter).addClass('active');
            $("#btnSave").empty();
           
            var arrayLength = allQuestions.length;
            var presentValue = counter + 1;
            console.log("value", counter);
            console.log("Length", allQuestions.length);
            if(counter>0)
             $("#btnSave").append($('<button type="button" onclick="previousBtn('+value+')" class="btn btn-light mr-4"> Previous  </button>'));
            $("#btnSave").append($('<button type="submit" onclick="submitForm()" class="btn btn-danger mr-2">' + (presentValue<arrayLength?'Next & Save':'Submit') + '</button>'));
            $("#form-questn").empty();

            $.each(allQuestions[value].TestQuestion, function (i, value) {
               // $("#form-questn").append($('<div class="card question mb-2 p-3"> <h4> ('+(i+1)+')  ' + value.AttachmentName + ' </h4><div class="option" > <label><input type="radio" id="opt'+(value.QuestionId)+'v'+1+'" name="' + value.QuestionId + '" value="1" class="choice" required /> Yes</label> <br /> <label><input type="radio" required id="opt'+(value.QuestionId)+'v'+2+'"   name="' + value.QuestionId + '" value="2" class="choice" /> No</label> <br /> <label><input type="radio" id="opt'+(value.QuestionId)+'v'+3+'"   name="' + value.QuestionId + '" value="3" class="choice" />  Not Applicable</label>  </div> </div>'));
                $("#form-questn").append($('<div class="card question mb-2 p-3"> <h4> (' + (i + 1) + ')' + value.AttachmentName + ' </h4>  <div><p class="card-body bg-primary py-2 px-2 d-flex align-items-center justify-content-between flex-wrap mb-0 text-white font-weight-medium"> Kindly download this  and fill, then uploads <a href="' + value.AttachmentUpload + '" class="btn btn-danger btn-sm mb-3 mt-2"><i class="fa fa-download fa-2x"></i>Download</a></p></div><div class="option" > 	<input type="file" name="fileUploadss" id="questionId=' + value.QuestionId + '*categoryId=' + cateId + '"  class="fileUploadss file-upload-default" placeholder="Upload Document"><div class="input-group col-xs-12"></div> </div><div class="ans'+value.QuestionId +'">  </div>   </div > '));
            })
            //Testing checked answer.
            $('.fileUploadss').change( function (e) {
                console.log("fileUploadss" + this.className);
                console.log("Id:::  " + this.id);
                var questionId = this.id.split('*')[0].replace('questionId=', '');
                var categoryId = this.id.split('*')[1].replace('categoryId=', '');
                var file = e.target.files[0];
                var fileData = new FormData();
                fileData.append(file.name, file);
                fileData.append("CategoryId", categoryId);
                fileData.append("QuestionId", questionId);
                saveQuestionDB(fileData);
                savedAnswers(cateId);
            });
             savedAnswers(cateId);
            
         
        }
        function fileSavedRecord(fileCheckee) {
            $('#fileSaved').empty();
            // var urlSavedAns = "@Url.Content("'+fileCheckee+'")";
           var newfileCheckee = "~Doc/" + fileCheckee;
            return   $('#fileSaved').append('<a target="_blank" href='+newfileCheckee+' class=""> <i class="mdi mdi-download mr-3 icon-lg text-warning"></i>Download Sample Uploaded</a>');
        }
        
        function savedAnswers(QuestionCatId) {
            var urlSavedAns='@Url.Action("GetAllResult")'
               $.ajax({
            url: urlSavedAns,
            type: 'GET',
            datatype: 'json',
            contentType: false,
            processData: false,
            async: false,
            data: 'QuestionCatId='+QuestionCatId+'',
                   success: function (response) {
                       if (response.data) {
                           $("div[class^='ans'],div[class*=' ans']").empty();

                           counterAns = response.data.answers.length;
                           $.each(response.data.answers, function (key, value) {
                               console.log('Value' + value)
                               $('.ans' + value.QuestionId).append('<a class="btn btn-danger btn-sm" href="' + value.FilePath + '"> View Upload</a>');
                               debugger;
                           });

                           fileCheck = response.data.FileDto;
                           if (fileCheck != null) {
                               fileSavedRecord(fileCheck);
                           }
                       }
                   }
        });
        }

        function previousBtn(value) {
            value -= value;
            displayCategoryQuestions(value);
        }
        function moveCategory(value) {
            //var check = validation();
            //if (check) {


               // displayCategoryQuestions(value);
           // }

        }
        function formFileUpload(cateId) {
            //Button
            $("#filetoup").val(null);
             $(".file-upload-info").val('Upload Sample');
             $("#savefileBtn").empty();
            $("#savefileBtn").append($(' <button onclick="saveFile(' + cateId + ')" class="btn btn-primary  btn-fw"> Upload Sample</button>'))


        }
        function saveQuestionDB(fileData) {
         
            var url = '@Url.Action("UploadAnswerAsync","AssessmentPortal")';
            $.ajax({
            url: url,
            type: 'post',
            datatype: 'json',
            contentType: false,
            processData: false,
            async: false,
            data: fileData,
            success: function (response) {
                console.log(response)
                if (response.data == "failed") {
                    toastr.error("Incorrect file format", "File failed to upload")
                }
                else {
                    fileCheck = response.data;
                    toastr.success("Successfully Submitted");
                   
                }
            }
        });
        }

        function fetchRecords() {
            // Fetch all the records from backend;
            // patchvalue
        }
        function saveFile(cateId) {

            var fileUpload = $('#filetoup').get(0);
            var files = fileUpload.files;
            console.log(files[0]);
            if (files[0] == undefined) {
                toastr.error("No file Selected", "File Validation");
                return;
            }
            var url='@Url.Action("UploadAnswerAsync","AssessmentPortal")'
        var fileData = new FormData();
            fileData.append(files[0].name, files[0]);
            fileData.append("CategoryId", cateId);


        $.ajax({
            url: url,
            type: 'post',
            datatype: 'json',
            contentType: false,
            processData: false,
            async: false,
            data: fileData,
            success: function (response) {
                console.log(response)
                if (response.data == "failed") {
                    toastr.error("Incorrect file format", "File failed to upload")
                }
                else {
                    fileCheck = response.data;
                    toastr.success("Successfully Upload Files");
                    fileSavedRecord(fileCheck);
                }
            }
        });
        }
        function submitForm() {
            // first check ur local db
            // if exist patch value to the db
            // else not check online;
            // and save into local data
            // if there's nothing online
            var arrayLength = allQuestions.length;
            var presentValue = counter + 1;

           
            var check = validation();

            if (check) {
                var formObject = $("#form-questn").serializeArray();
                var CategoryId = allQuestions[counter].QuestionCategoryId;
                var formData = { QuestionCategoryId: CategoryId, Questionlists: formObject, IsCompleted:presentValue == arrayLength };
                if (presentValue < arrayLength)
                            toastr.success("Move to the next Question Category", "Notification");
                        else {
                            toastr.success("Your assessment has been submitted", "Notification");
                            finalAssessment();
                        }


                         if (presentValue < arrayLength) {
                displayCategoryQuestions(presentValue)
            }
            }
//            localStorage.setItem("","");
        }
        function validation() {
            // file Upload
            // Input type
            debugger;
            var getcount = allQuestions[counter].Count;
            var fieldCount = counterAns
            if (fieldCount != getcount) {
                getcount =getcount - fieldCount  ;
                console.log(getcount);
                toastr.error('kindly, upload all the required documents <br/>  '+ getcount +'  (s) left to be uploaded!!!', "Validation");
                return false;
            }
            return true;
        }

        function finalAssessment() {
            var url = '@Url.Action("SaveFinalAssessment","AssessmentPortal")';
            $.ajax({
            url: url,
            type: 'GET',
            datatype: 'json',
            contentType: false,
            processData: false,
            async: false,
            success: function (response) {
                console.log(response)
                if (!response.data) {
                    toastr.error('Error occured while submitting your files /r contact the Admin on this platform')
                }
                else {
                    toastr.success("Successfully Submitted");
                    var url = '@Url.Action("Dashboard", "AssessmentPortal")';
                    window.location.href = url;
   
                 
                }
            }
        });
}

    </script>
    @Scripts.Render("~/bundles/bootstrap")
    <script src="~/Content/vendors/base/vendor.bundle.base.js"></script>
    <script src="~/Scripts/js/toastr.js"></script>
    <script src="~/Scripts/js/off-canvas.js"></script>
    <script src="~/Scripts/js/hoverable-collapse.js"></script>
    <script src="~/Scripts/js/template.js"></script>
    <script src="~/Scripts/js/loader.js"></script>

    @Scripts.Render("~/bundles/jquery-ui")

    <script src="~/Scripts/js/file-upload.js"></script>

</body>
</html>

<!-- JQUERY FOR NEXT AND PREV FUNCTIONALITY -->
